=== debian/changelog ===
cppgir (0~git20230606.960fe05-1) unstable; urgency=low

  * Initial upload. (Closes: #1037265)

 -- Nicholas Guriev <guriev-ns@ya.ru>  Fri, 09 Jun 2023 21:27:53 +0300
