=== debian/control ===
Source: cppgir
Section: devel
Priority: optional
Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
Build-Depends: debhelper-compat (= 13)
Build-Depends-Arch:
 cmake (>= 3.5),
 libboost-dev (>= 1.58),
 libboost-program-options-dev,
 libfmt-dev,
 ronn <!nodoc>,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://gitlab.com/mnauw/cppgir
Vcs-Git: https://salsa.debian.org/mymedia/cppgir.git
Vcs-Browser: https://salsa.debian.org/mymedia/cppgir

Package: cppgir
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++ binding wrapper generator for GObject introspection
 cppgir processes .gir files derived from GObject-Introspection annotations into
 a set of C++ files defining suitable namespaces, classes and other types that
 together from a C++ binding. In this way, the plain C libraries and objects
 become available as native objects along with managed resource handling.
