=== debian/rules ===
#!/usr/bin/make -f

# The package ships the architecture independent library.
CMAKE_FLAGS = -DCMAKE_INSTALL_LIBDIR=lib
ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  CMAKE_FLAGS += -DBUILD_TESTING=OFF
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)
