## cppgir 0~git20230822.89cf56d

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.5.0 FATAL_ERROR)
+cmake_minimum_required(VERSION 3.14.0 FATAL_ERROR)
 if (POLICY CMP0077)
     cmake_policy(SET CMP0077 NEW)
 endif ()
@@ -26,7 +26,10 @@
 
 ## OPTIONS ##
 option(BUILD_DOC "build documentation" ON)
+option(BUILD_EXAMPLES "build examples" ON)
 option(EXAMPLES_EXPECTED "use expected<> in examples" OFF)
+option(EXAMPLES_DL "use dynamic symbol load in examples" OFF)
+option(INTERNAL_EXPECTED "use internal expected-lite" ON)
 
 ## CONTENT ##
 
@@ -63,8 +66,9 @@
     -DDEFAULT_GIRPATH=${GI_DEFAULT_GIRPATH})
 target_compile_definitions(cppgir PRIVATE
     -DDEFAULT_IGNORE_FILE=${GI_IGNORE_FILE_INSTALL_DIR}/${GI_IGNORE_FILE}:${GI_IGNORE_FILE_INSTALL_DIR}/${GI_IGNORE_FILE_PLATFORM})
-target_link_libraries(cppgir Boost::program_options stdc++fs ${FORMAT_LIBRARIES})
-set_property(TARGET cppgir PROPERTY CXX_STANDARD 14)
+target_link_libraries(cppgir Boost::program_options ${FORMAT_LIBRARIES})
+set_property(TARGET cppgir PROPERTY CXX_STANDARD 17)
+add_executable(CppGir::cppgir ALIAS cppgir)
 
 add_library(gi INTERFACE)
 target_include_directories(gi INTERFACE
@@ -75,21 +79,31 @@
     "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}/gi>"
     "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}/override>"
 )
-
-set(EXPECTED_LITE_INCLUDE "expected-lite/include")
-if (EXISTS ${CMAKE_CURRENT_LIST_DIR}/${EXPECTED_LITE_INCLUDE}/nonstd/expected.hpp)
-    target_include_directories(gi INTERFACE
-        "$<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/${EXPECTED_LITE_INCLUDE}>"
-    )
+add_library(CppGir::gi ALIAS gi)
+
+if (INTERNAL_EXPECTED)
+    set(EXPECTED_LITE_INCLUDE "expected-lite/include")
+    if (EXISTS ${CMAKE_CURRENT_LIST_DIR}/${EXPECTED_LITE_INCLUDE}/nonstd/expected.hpp)
+        target_include_directories(gi INTERFACE
+            "$<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/${EXPECTED_LITE_INCLUDE}>"
+        )
+    else ()
+        message (FATAL_ERROR "missing submodule expected-lite")
+    endif ()
 else ()
-    message (FATAL_ERROR "missing submodule expected-lite")
-endif ()
-
-include(FindPkgConfig)
-pkg_check_modules(GOBJECT gobject-2.0)
-pkg_check_modules(GIO gio-2.0 gio-unix-2.0)
-pkg_check_modules(GST gstreamer-1.0)
-pkg_check_modules(GTK gtk+-3.0)
+    find_package(expected-lite REQUIRED)
+    target_link_libraries(gi INTERFACE nonstd::expected-lite)
+endif ()
+
+if (BUILD_EXAMPLES OR BUILD_TESTING)
+    include(FindPkgConfig)
+    pkg_check_modules(GOBJECT gobject-2.0)
+endif ()
+if (BUILD_EXAMPLES)
+    pkg_check_modules(GIO gio-2.0 gio-unix-2.0)
+    pkg_check_modules(GST gstreamer-1.0)
+    pkg_check_modules(GTK gtk+-3.0)
+endif ()
 
 ## TEST ##
 
@@ -108,9 +122,15 @@
 # generated wrappers' dir
 set (GENERATED_DIR_DEFAULT "/tmp/gi")
 set (GENERATED_ARGS "")
+set (EXAMPLES_LIBS "")
 if (EXAMPLES_EXPECTED)
-    set (GENERATED_DIR_DEFAULT "/tmp/gi_expected")
-    set (GENERATED_ARGS "--expected")
+    set (GENERATED_DIR_DEFAULT "${GENERATED_DIR_DEFAULT}_expected")
+    set (GENERATED_ARGS "${GENERATED_ARGS}" "--expected")
+endif ()
+if (EXAMPLES_DL)
+    set (GENERATED_DIR_DEFAULT "${GENERATED_DIR_DEFAULT}_dl")
+    set (GENERATED_ARGS "${GENERATED_ARGS}" "--dl")
+    set (EXAMPLES_LIBS ${CMAKE_DL_LIBS})
 endif ()
 if (NOT GENERATED_DIR)
     set (GENERATED_DIR ${GENERATED_DIR_DEFAULT})
@@ -118,6 +138,14 @@
 
 set(EXAMPLE_TARGETS "")
 set(EXAMPLE_NS "")
+# if both --dl and --expected are enabled,
+# all function return value become gi::result<>
+# to keep examples straight and simple,
+# only few of them are adjusted to handle that scenario
+set(PLAIN_API ON)
+if (EXAMPLES_DL AND EXAMPLES_EXPECTED)
+    set(PLAIN_API OFF)
+endif ()
 
 if (GOBJECT_FOUND)
     add_executable(example-gobject EXCLUDE_FROM_ALL examples/gobject.cpp)
@@ -130,34 +158,44 @@
     set(EXAMPLE_NS ${EXAMPLE_NS} GObject-2.0)
 endif ()
 
+if (GIO_FOUND AND PLAIN_API)
+    add_executable(example-gio EXCLUDE_FROM_ALL examples/gio.cpp)
+    target_compile_options(example-gio PRIVATE ${GIO_CFLAGS})
+    target_link_libraries(example-gio PRIVATE ${GIO_LDFLAGS})
+    set_property(TARGET example-gio PROPERTY CXX_STANDARD 17)
+
+    message(STATUS "adding Gio communication example")
+    set(EXAMPLE_TARGETS ${EXAMPLE_TARGETS} example-gio)
+endif ()
+
 if (GIO_FOUND)
-    add_executable(example-gio EXCLUDE_FROM_ALL examples/gio.cpp)
-    target_compile_options(example-gio PRIVATE ${GIO_CFLAGS} ${GOBJECT_CFLAGS} ${GIO_CFLAGS})
-    target_link_libraries(example-gio PRIVATE ${GIO_LDFLAGS} ${GOBJECT_LDFLAGS} ${GIO_LDFLAGS})
-
     add_executable(example-gio-dbus-client EXCLUDE_FROM_ALL examples/gio-dbus-client.cpp)
-    target_compile_options(example-gio-dbus-client PRIVATE ${GIO_CFLAGS} ${GOBJECT_CFLAGS})
-    target_link_libraries(example-gio-dbus-client PRIVATE ${GIO_LDFLAGS} ${GOBJECT_LDFLAGS})
-
+    target_compile_options(example-gio-dbus-client PRIVATE ${GIO_CFLAGS})
+    target_link_libraries(example-gio-dbus-client PRIVATE ${GIO_LDFLAGS})
+
+    message(STATUS "adding Gio dbus example")
+    set(EXAMPLE_TARGETS ${EXAMPLE_TARGETS} example-gio-dbus-client)
+    set(EXAMPLE_NS ${EXAMPLE_NS} Gio-2.0)
+endif ()
+
+if (GIO_FOUND AND PLAIN_API)
     find_package(Boost 1.65 COMPONENTS fiber)
     if (Boost_FOUND)
         # no import target; multiple calls do not override first call targets
         add_executable(example-gio-async EXCLUDE_FROM_ALL examples/gio-async.cpp)
         target_include_directories(example-gio-async PRIVATE ${Boost_INCLUDE_DIRS})
-        target_compile_options(example-gio-async PRIVATE ${GIO_CFLAGS} ${GOBJECT_CFLAGS})
-        target_link_libraries(example-gio-async PRIVATE ${GIO_LDFLAGS} ${GOBJECT_LDFLAGS} ${Boost_LIBRARIES})
-        set(GIO_ASYNC_EXAMPLE_TARGET example-gio-async)
+        target_compile_options(example-gio-async PRIVATE ${GIO_CFLAGS})
+        target_link_libraries(example-gio-async PRIVATE ${GIO_LDFLAGS} ${Boost_LIBRARIES})
+
+        message(STATUS "adding Gio async example")
+        set(EXAMPLE_TARGETS ${EXAMPLE_TARGETS} example-gio-async)
     else ()
         set(GIO_ASYNC_EXAMPLE_TARGET "")
         message(STATUS "disabling Gio async example")
     endif ()
-
-    message(STATUS "adding Gio examples")
-    set(EXAMPLE_TARGETS ${EXAMPLE_TARGETS} example-gio example-gio-dbus-client ${GIO_ASYNC_EXAMPLE_TARGET})
-    set(EXAMPLE_NS ${EXAMPLE_NS} Gio-2.0)
-endif ()
-
-if (GST_FOUND)
+endif ()
+
+if (GST_FOUND AND PLAIN_API)
     add_executable(example-gst EXCLUDE_FROM_ALL examples/gst.cpp)
     # add generated files
     foreach (GENSRC IN ITEMS ${GENERATED_DIR}/glib/glib.cpp
@@ -174,10 +212,10 @@
     set(EXAMPLE_NS ${EXAMPLE_NS} Gst-1.0)
 endif ()
 
-if (GTK_FOUND)
+if (GTK_FOUND AND PLAIN_API)
     add_executable(example-gtk EXCLUDE_FROM_ALL examples/gtk.cpp examples/gtk-obj.cpp)
-    target_compile_options(example-gtk PRIVATE ${GOBJECT_CFLAGS} ${GTK_CFLAGS})
-    target_link_libraries(example-gtk PRIVATE ${GOBJECT_LDFLAGS} ${GTK_LIBRARIES})
+    target_compile_options(example-gtk PRIVATE ${GTK_CFLAGS})
+    target_link_libraries(example-gtk PRIVATE ${GTK_LIBRARIES})
 
     message(STATUS "adding Gtk example")
     set(EXAMPLE_TARGETS ${EXAMPLE_TARGETS} example-gtk)
@@ -185,12 +223,14 @@
 endif ()
 
 # optional Qt example
-find_package(Qt5Core 5.9)
-if (Qt5Core_FOUND AND GIO_FOUND)
+if (BUILD_EXAMPLES)
+    find_package(Qt5Core 5.9)
+endif ()
+if (Qt5Core_FOUND AND GIO_FOUND AND PLAIN_API)
     set(CMAKE_INCLUDE_CURRENT_DIR ON)
     add_executable(example-gio-qt-async EXCLUDE_FROM_ALL examples/gio-qt-async.cpp)
-    target_compile_options(example-gio-qt-async PRIVATE ${GIO_CFLAGS} ${GOBJECT_CFLAGS})
-    target_link_libraries(example-gio-qt-async PRIVATE ${GIO_LDFLAGS} ${GOBJECT_LDFLAGS} Qt5::Core)
+    target_compile_options(example-gio-qt-async PRIVATE ${GIO_CFLAGS})
+    target_link_libraries(example-gio-qt-async PRIVATE ${GIO_LDFLAGS} Qt5::Core)
     set_target_properties(example-gio-qt-async PROPERTIES AUTOMOC ON)
 
     message(STATUS "adding Qt GIO async example")
@@ -200,10 +240,17 @@
 add_custom_command(OUTPUT ${GENERATED_DIR}
     COMMENT "Generating wrapper code for: ${EXAMPLE_NS}"
     DEPENDS cppgir
-    COMMAND cppgir --class --ignore ${GI_IGNORE_FILE_DIR}/${GI_IGNORE_FILE}:${GI_IGNORE_FILE_DIR}/${GI_IGNORE_FILE_PLATFORM}
+    COMMAND cppgir --class --class-full --optional
+        --ignore ${GI_IGNORE_FILE_DIR}/${GI_IGNORE_FILE}:${GI_IGNORE_FILE_DIR}/${GI_IGNORE_FILE_PLATFORM}
         ${GENERATED_ARGS} --output ${GENERATED_DIR} ${EXAMPLE_NS}
     COMMAND cmake -E touch_nocreate ${GENERATED_DIR}
     WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR})
+
+# example might have been added if dependencies found
+# make sure to disable as needed
+if (NOT BUILD_EXAMPLES)
+    set(EXAMPLE_TARGETS "")
+endif ()
 
 message(STATUS "example programs: ${EXAMPLE_TARGETS}")
 add_custom_target(examples)
@@ -213,7 +260,7 @@
 
 add_custom_target(wrappers DEPENDS ${GENERATED_DIR})
 foreach (example ${EXAMPLE_TARGETS})
-    target_link_libraries(${example} PRIVATE gi)
+    target_link_libraries(${example} PRIVATE gi ${EXAMPLES_LIBS})
     target_include_directories(${example} PRIVATE ${GENERATED_DIR})
     add_dependencies(${example} wrappers)
 endforeach ()
@@ -234,15 +281,13 @@
     add_custom_target(manpages ALL DEPENDS cppgir.1)
 endif()
 
-# generator
-install(TARGETS cppgir
-    DESTINATION ${CMAKE_INSTALL_FULL_BINDIR})
-
 # headers
 install(DIRECTORY gi override
     DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/${PROJECT_NAME})
-install(DIRECTORY ${EXPECTED_LITE_INCLUDE}/nonstd
-    DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/${PROJECT_NAME}/gi)
+if (INTERNAL_EXPECTED)
+    install(DIRECTORY ${EXPECTED_LITE_INCLUDE}/nonstd
+        DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/${PROJECT_NAME}/gi)
+endif ()
 
 # doc
 install(FILES README.md docs/cppgir.md
@@ -267,45 +312,19 @@
     DESTINATION ${GI_IGNORE_FILE_INSTALL_DIR})
 
 # cmake EXPORTS
-set(CONFIG_PACKAGE_LOCATION lib/cmake/${PROJECT_NAME})
+set(CONFIG_PACKAGE_LOCATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})
 set(CONFIG_VERSION_NAME ${PROJECT_NAME}-config-version.cmake)
 set(CONFIG_TARGETS_NAME ${PROJECT_NAME}-targets.cmake)
 set(CONFIG_NAME ${PROJECT_NAME}-config.cmake)
+if (INTERNAL_EXPECTED)
+    set(CONFIG_NAME_IN ${CONFIG_NAME})
+else ()
+    set(CONFIG_NAME_IN ${PROJECT_NAME}-config-deps.cmake)
+endif ()
 set(TARGETS_EXPORT_NAME CppGirTargets)
 
-install(TARGETS gi EXPORT "${TARGETS_EXPORT_NAME}")
-
-include(CMakePackageConfigHelpers)
-write_basic_package_version_file(
-    "${CMAKE_CURRENT_BINARY_DIR}/cmake/${CONFIG_VERSION_NAME}"
-    VERSION ${PROJECT_VERSION}
-    COMPATIBILITY SameMajorVersion
-)
-
-install(FILES cmake/${CONFIG_NAME}
-    "${CMAKE_CURRENT_BINARY_DIR}/cmake/${CONFIG_VERSION_NAME}"
-    DESTINATION ${CONFIG_PACKAGE_LOCATION}
-)
-
-export(EXPORT ${TARGETS_EXPORT_NAME}
-    FILE "${CMAKE_CURRENT_BINARY_DIR}/cmake/${CONFIG_TARGETS_NAME}"
-    NAMESPACE CppGir::
-)
-
-install(EXPORT ${TARGETS_EXPORT_NAME}
-  FILE ${CONFIG_TARGETS_NAME}
-  NAMESPACE CppGir::
-  DESTINATION ${CONFIG_PACKAGE_LOCATION}
-)
-
-# uninstall target;
-# intermediate directories are not removed though
-if(NOT TARGET uninstall)
-  configure_file(
-    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake-uninstall.cmake.in"
-    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
-    IMMEDIATE @ONLY)
-
-  add_custom_target(uninstall
-    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
-endif()
+# generator
+set_property(TARGET cppgir
+    PROPERTY IMPORTED_LOCATION "${CMAKE_INSTALL_FULL_BINDIR}")
+install(TARGETS cppgir
+    DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}
