=== debian/changelog ===
cppgir (0~git20230822.89cf56d-1revyos1) unstable; urgency=medium

  * Use gcc-13

 -- Han Gao <gaohan@iscas.ac.cn>  Thu, 19 Oct 2023 20:56:57 +0800

cppgir (0~git20230822.89cf56d-1) unstable; urgency=medium

  * Update to the latest upstream commit.
  * Update d/rules and d/patches to match the upstream version.
  * Add missing build dependencies for testing.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sat, 26 Aug 2023 13:11:26 +0300
