=== debian/control ===
--- 
+++ 
@@ -6,8 +6,13 @@
 Build-Depends-Arch:
  cmake (>= 3.5),
  libboost-dev (>= 1.58),
+ gcc-13, g++-13,
  libboost-program-options-dev,
  libfmt-dev,
+ libglib2.0-dev <!nocheck>,
+ libgstreamer1.0-dev <!nocheck>,
+ libgtk-3-dev <!nocheck>,
+ qtbase5-dev (>= 5.9) <!nocheck>,
  ronn <!nodoc>,
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
