=== debian/rules ===
#!/usr/bin/make -f

# The package ships the architecture independent library.
CMAKE_FLAGS = -DCMAKE_INSTALL_LIBDIR=lib -DINTERNAL_EXPECTED=OFF
ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  CMAKE_FLAGS += -DBUILD_TESTING=OFF -DBUILD_EXAMPLES=OFF
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
export CC=gcc-13
export CXX=g++-13

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)
