## cppgir 0~git20231019.ff975ba

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,28 +27,60 @@
 ## OPTIONS ##
 option(BUILD_DOC "build documentation" ON)
 option(BUILD_EXAMPLES "build examples" ON)
+option(BUILD_EMBED_IGNORE "embed default ignore" OFF)
 option(EXAMPLES_EXPECTED "use expected<> in examples" OFF)
 option(EXAMPLES_DL "use dynamic symbol load in examples" OFF)
 option(INTERNAL_EXPECTED "use internal expected-lite" ON)
+set(BUILD_FMT AUTO CACHE STRING "format library")
+set_property(CACHE BUILD_FMT PROPERTY STRINGS AUTO FMTLIB STDFORMAT)
 
 ## CONTENT ##
 
-find_package(Boost 1.58 REQUIRED COMPONENTS program_options)
-
+find_package(Boost 1.58 REQUIRED)
+
+# check fmtlib
 find_path(FORMAT_INCLUDE_DIRS fmt/format.h)
 find_library(FORMAT_LIBRARIES fmt)
 if (${FORMAT_INCLUDE_DIRS} STREQUAL "FORMAT_INCLUDE_DIRS-NOTFOUND" OR
     ${FORMAT_LIBRARIES} STREQUAL "FORMAT_LIBRARIES-NOTFOUND")
-    message (FATAL_ERROR "fmtlib.net format library not found")
-endif ()
+    set(HAVE_FMTLIB OFF)
+else()
+    set(HAVE_FMTLIB ON)
+endif()
+message(STATUS "fmtlib available status: ${HAVE_FMTLIB}")
+# check C++20 format
+try_compile(HAVE_STDFORMAT ${CMAKE_BINARY_DIR}
+    SOURCES ${CMAKE_CURRENT_LIST_DIR}/cmake/cpp20_format.cpp
+    CXX_STANDARD 20)
+message(STATUS "std::format available status: ${HAVE_STDFORMAT}")
+
+# check and decide on which fmt to use
+set(USE_FMTLIB NONE)
+if (BUILD_FMT STREQUAL "AUTO")
+    if (HAVE_FMTLIB)
+        set(USE_FMTLIB ON)
+    elseif (HAVE_STDFORMAT)
+        set(USE_FMTLIB OFF)
+    endif()
+elseif(BUILD_FMT STREQUAL "FMTLIB" AND HAVE_FMTLIB)
+    set(USE_FMTLIB ON)
+elseif(BUILD_FMT STREQUAL "STDFORMAT" AND HAVE_STDFORMAT)
+    set(USE_FMTLIB OFF)
+endif()
+if (USE_FMTLIB STREQUAL "NONE")
+    message (FATAL_ERROR "no format library found")
+endif()
 
 # required ignore file
 set(GI_IGNORE_FILE_DIR data)
 set(GI_IGNORE_FILE cppgir.ignore)
+file(READ data/cppgir.ignore CPPGIR_IGNORE)
 if (UNIX)
     set(GI_IGNORE_FILE_PLATFORM cppgir_unix.ignore)
+    file(READ data/cppgir_unix.ignore CPPGIR_UNIX_IGNORE)
 else ()
     set(GI_IGNORE_FILE_PLATFORM cppgir_win.ignore)
+    file(READ data/cppgir_win.ignore CPPGIR_WIN_IGNORE)
 endif ()
 set(GI_IGNORE_FILE_INSTALL_DIR ${CMAKE_INSTALL_FULL_DATADIR}/${PROJECT_NAME})
 
@@ -64,10 +96,22 @@
     tools/common.hpp)
 target_compile_definitions(cppgir PRIVATE
     -DDEFAULT_GIRPATH=${GI_DEFAULT_GIRPATH})
-target_compile_definitions(cppgir PRIVATE
-    -DDEFAULT_IGNORE_FILE=${GI_IGNORE_FILE_INSTALL_DIR}/${GI_IGNORE_FILE}:${GI_IGNORE_FILE_INSTALL_DIR}/${GI_IGNORE_FILE_PLATFORM})
-target_link_libraries(cppgir Boost::program_options ${FORMAT_LIBRARIES})
-set_property(TARGET cppgir PROPERTY CXX_STANDARD 17)
+if (BUILD_EMBED_IGNORE)
+    # generate embedded ignore data
+    configure_file(tools/ignore.hpp.in tools/ignore.hpp @ONLY)
+    target_include_directories(cppgir PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/tools)
+    set(GENERATED_IGNORE "")
+else()
+    target_compile_definitions(cppgir PRIVATE
+        -DDEFAULT_IGNORE_FILE=${GI_IGNORE_FILE_INSTALL_DIR}/${GI_IGNORE_FILE}:${GI_IGNORE_FILE_INSTALL_DIR}/${GI_IGNORE_FILE_PLATFORM})
+    set(GENERATED_IGNORE --ignore ${GI_IGNORE_FILE_DIR}/${GI_IGNORE_FILE}:${GI_IGNORE_FILE_DIR}/${GI_IGNORE_FILE_PLATFORM})
+endif()
+if (USE_FMTLIB)
+    target_link_libraries(cppgir ${FORMAT_LIBRARIES})
+    set_property(TARGET cppgir PROPERTY CXX_STANDARD 17)
+else()
+    set_property(TARGET cppgir PROPERTY CXX_STANDARD 20)
+endif()
 add_executable(CppGir::cppgir ALIAS cppgir)
 
 add_library(gi INTERFACE)
@@ -91,8 +135,13 @@
         message (FATAL_ERROR "missing submodule expected-lite")
     endif ()
 else ()
-    find_package(expected-lite REQUIRED)
-    target_link_libraries(gi INTERFACE nonstd::expected-lite)
+    find_package(expected-lite)
+    if (expected-lite_FOUND)
+        target_link_libraries(gi INTERFACE nonstd::expected-lite)
+    else ()
+        target_compile_features(gi INTERFACE cxx_std_23)
+        message (WARNING "thus cppgir headers will require C++23")
+    endif ()
 endif ()
 
 if (BUILD_EXAMPLES OR BUILD_TESTING)
@@ -239,9 +288,9 @@
 
 add_custom_command(OUTPUT ${GENERATED_DIR}
     COMMENT "Generating wrapper code for: ${EXAMPLE_NS}"
-    DEPENDS cppgir
-    COMMAND cppgir --class --class-full --optional
-        --ignore ${GI_IGNORE_FILE_DIR}/${GI_IGNORE_FILE}:${GI_IGNORE_FILE_DIR}/${GI_IGNORE_FILE_PLATFORM}
+    DEPENDS cppgir ${GI_IGNORE_FILE_DIR}/${GI_IGNORE_FILE} ${GI_IGNORE_FILE_DIR}/${GI_IGNORE_FILE_PLATFORM}
+    COMMAND cppgir --class --class-full
+        ${GENERATED_IGNORE}
         ${GENERATED_ARGS} --output ${GENERATED_DIR} ${EXAMPLE_NS}
     COMMAND cmake -E touch_nocreate ${GENERATED_DIR}
     WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR})
@@ -278,53 +327,3 @@
         COMMAND ${RONN} --roff --pipe ${CMAKE_CURRENT_LIST_DIR}/docs/cppgir.md > cppgir.1
         DEPENDS docs/cppgir.md
         WORKING_DIRECTORY .)
-    add_custom_target(manpages ALL DEPENDS cppgir.1)
-endif()
-
-# headers
-install(DIRECTORY gi override
-    DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/${PROJECT_NAME})
-if (INTERNAL_EXPECTED)
-    install(DIRECTORY ${EXPECTED_LITE_INCLUDE}/nonstd
-        DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/${PROJECT_NAME}/gi)
-endif ()
-
-# doc
-install(FILES README.md docs/cppgir.md
-    DESTINATION ${CMAKE_INSTALL_FULL_DOCDIR})
-install(DIRECTORY examples
-    DESTINATION ${CMAKE_INSTALL_FULL_DOCDIR})
-if (TARGET manpages)
-    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cppgir.1
-        DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man1)
-endif()
-
-# pkgconfig
-set(PKG_CONFIG "${CMAKE_BINARY_DIR}/${PROJECT_NAME}.pc")
-set(PKG_CONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
-# configure pkg config file
-configure_file("cmake/cppgir.pc.in" "${PKG_CONFIG}" @ONLY)
-install(FILES "${PKG_CONFIG}"
-    DESTINATION "${PKG_CONFIG_INSTALL_DIR}")
-
-# ignore file
-install(FILES ${GI_IGNORE_FILE_DIR}/${GI_IGNORE_FILE} ${GI_IGNORE_FILE_DIR}/${GI_IGNORE_FILE_PLATFORM}
-    DESTINATION ${GI_IGNORE_FILE_INSTALL_DIR})
-
-# cmake EXPORTS
-set(CONFIG_PACKAGE_LOCATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})
-set(CONFIG_VERSION_NAME ${PROJECT_NAME}-config-version.cmake)
-set(CONFIG_TARGETS_NAME ${PROJECT_NAME}-targets.cmake)
-set(CONFIG_NAME ${PROJECT_NAME}-config.cmake)
-if (INTERNAL_EXPECTED)
-    set(CONFIG_NAME_IN ${CONFIG_NAME})
-else ()
-    set(CONFIG_NAME_IN ${PROJECT_NAME}-config-deps.cmake)
-endif ()
-set(TARGETS_EXPORT_NAME CppGirTargets)
-
-# generator
-set_property(TARGET cppgir
-    PROPERTY IMPORTED_LOCATION "${CMAKE_INSTALL_FULL_BINDIR}")
-install(TARGETS cppgir
-    DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}
