=== debian/changelog ===
cppgir (0~git20231019.ff975ba-2~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.
  * Readd libfmt-dev build dependency.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Thu, 09 Nov 2023 19:55:51 +0300

cppgir (0~git20231019.ff975ba-2) unstable; urgency=medium

  * New Set-mxgot-flag.patch fixes build on MIPS 64-bit Little Endian platform.
  * Skip Gio async example on platforms where Boost.Fiber is unavailable.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Mon, 23 Oct 2023 22:38:39 +0300

cppgir (0~git20231019.ff975ba-1) unstable; urgency=medium

  * Update to the latest upstream commit.
  * Remove no longer needed Optional-value.patch
  * Add missing build dependency, libgirepository1.0-dev (Closes: #1054195)

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sat, 21 Oct 2023 18:42:38 +0300

cppgir (0~git20231003.e856d76-1) unstable; urgency=medium

  * Update to the latest upstream commit.
  * Replace patches with fixes of build of examples.
  * Update build dependencies, new libboost-fiber-dev.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Wed, 18 Oct 2023 13:13:42 +0300
