=== debian/control ===
--- 
+++ 
@@ -4,11 +4,11 @@
 Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
 Build-Depends: debhelper-compat (= 13)
 Build-Depends-Arch:
- cmake (>= 3.5),
+ cmake (>= 3.14),
  libboost-dev (>= 1.58),
- gcc-13, g++-13,
- libboost-program-options-dev,
+ libboost-fiber-dev (>= 1.65) [amd64 arm64 armel armhf hurd-i386 i386 mips64el powerpc ppc64el riscv64 s390x] <!nocheck>,
  libfmt-dev,
+ libgirepository1.0-dev <!nocheck>,
  libglib2.0-dev <!nocheck>,
  libgstreamer1.0-dev <!nocheck>,
  libgtk-3-dev <!nocheck>,
