## cppgir 2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 if (POLICY CMP0069)
     cmake_policy(SET CMP0069 NEW)
 endif ()
-project(cppgir VERSION 0.1.0)
+project(cppgir VERSION 2.0.0)
 
 include(GNUInstallDirs)
 include(CTest)
@@ -13,7 +13,7 @@
 
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
-set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD 14)
 
 if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" OR "${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
     add_compile_options (-Wall -Wextra $<$<COMPILE_LANGUAGE:CXX>:-Wnon-virtual-dtor>)
@@ -157,13 +157,21 @@
 ## TEST ##
 
 if (BUILD_TESTING AND GOBJECT_FOUND)
-    add_executable(gi-test test/main.cpp
+    add_library(ltest
         test/test_object.c test/test_object.h test/test_boxed.c test/test_boxed.h)
-    target_include_directories(gi-test PRIVATE "gi" "override")
-    target_link_libraries(gi-test gi ${GOBJECT_LDFLAGS})
-    target_compile_options(gi-test PRIVATE ${GOBJECT_CFLAGS})
-
+    target_include_directories(ltest PUBLIC "gi" "override")
+    target_link_libraries(ltest gi ${GOBJECT_LDFLAGS})
+    target_compile_options(ltest PUBLIC ${GOBJECT_CFLAGS})
+
+    add_executable(gi-test test/main.cpp)
+    target_link_libraries(gi-test PRIVATE ltest)
     add_test(NAME gi-test COMMAND gi-test)
+
+    # a C++17 version of the above
+    add_executable(gi-test-17 test/main.cpp)
+    target_link_libraries(gi-test-17 PRIVATE ltest)
+    set_property(TARGET gi-test-17 PROPERTY CXX_STANDARD 17)
+    add_test(NAME gi-test-17 COMMAND gi-test-17)
 endif ()
 
 ## EXAMPLES ##
@@ -195,6 +203,9 @@
 if (EXAMPLES_DL AND EXAMPLES_EXPECTED)
     set(PLAIN_API OFF)
 endif ()
+
+include(CheckCXXCompilerFlag)
+check_cxx_compiler_flag("-mxgot" NEEDS_LARGE_GOT)
 
 if (GOBJECT_FOUND)
     add_executable(example-gobject EXCLUDE_FROM_ALL examples/gobject.cpp)
@@ -254,7 +265,13 @@
     endforeach ()
     target_link_libraries(example-gst PRIVATE ${GST_LDFLAGS})
     target_compile_options(example-gst PRIVATE ${GST_CFLAGS})
+    # a lot of class methods are wrapped these days, so there is some overlap
+    # however, no class implementation is used here, so arrange for suppression
+    target_compile_definitions(example-gst PRIVATE GI_CLASS_IMPL_PRAGMA=1)
     set_property(TARGET example-gst PROPERTY CXX_STANDARD 14)
+    if (NEEDS_LARGE_GOT)
+        set_property(SOURCE ${GENERATED_DIR}/gst/gst.cpp APPEND PROPERTY COMPILE_OPTIONS "-mxgot")
+    endif ()
 
     message(STATUS "adding Gst example")
     set(EXAMPLE_TARGETS ${EXAMPLE_TARGETS} example-gst)
@@ -265,6 +282,9 @@
     add_executable(example-gtk EXCLUDE_FROM_ALL examples/gtk.cpp examples/gtk-obj.cpp)
     target_compile_options(example-gtk PRIVATE ${GTK_CFLAGS})
     target_link_libraries(example-gtk PRIVATE ${GTK_LIBRARIES})
+    if (NEEDS_LARGE_GOT)
+        set_property(SOURCE examples/gtk-obj.cpp APPEND PROPERTY COMPILE_OPTIONS "-mxgot")
+    endif ()
 
     message(STATUS "adding Gtk example")
     set(EXAMPLE_TARGETS ${EXAMPLE_TARGETS} example-gtk)
@@ -302,28 +322,3 @@
 endif ()
 
 message(STATUS "example programs: ${EXAMPLE_TARGETS}")
-add_custom_target(examples)
-if (EXAMPLE_TARGETS)
-    add_dependencies(examples ${EXAMPLE_TARGETS})
-endif ()
-
-add_custom_target(wrappers DEPENDS ${GENERATED_DIR})
-foreach (example ${EXAMPLE_TARGETS})
-    target_link_libraries(${example} PRIVATE gi ${EXAMPLES_LIBS})
-    target_include_directories(${example} PRIVATE ${GENERATED_DIR})
-    add_dependencies(${example} wrappers)
-endforeach ()
-
-
-## INSTALL ##
-
-# manpage processor
-find_program(RONN ronn DOC "ronn markdown man page processor")
-if (${RONN} STREQUAL "RONN-NOTFOUND")
-    message(STATUS "ronn manpage processor not found; not building manpage")
-elseif (BUILD_DOC)
-    message(STATUS "building manpage")
-    add_custom_command(OUTPUT cppgir.1
-        COMMAND ${RONN} --roff --pipe ${CMAKE_CURRENT_LIST_DIR}/docs/cppgir.md > cppgir.1
-        DEPENDS docs/cppgir.md
-        WORKING_DIRECTORY .)
