=== debian/changelog ===
cppgir (2.0-2) unstable; urgency=medium

  * Add gi-restrict-string-template-conversion-operator.patch from upstream Git.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Mon, 08 Jan 2024 11:48:52 +0300

cppgir (2.0-1) unstable; urgency=medium

  * New upstream release.
  * Switch uscan(1) to GitLab generated tarballs, start versioning.
  * Replace patches:
    - Remove applied Set-mxgot-flag.patch
    - Add taken from upstream
      gi-avoid-incomplete-type-in-std::is_convertible.patch

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sun, 07 Jan 2024 21:40:40 +0300
