=== debian/control ===
--- 
+++ 
@@ -7,7 +7,6 @@
  cmake (>= 3.14),
  libboost-dev (>= 1.58),
  libboost-fiber-dev (>= 1.65) [amd64 arm64 armel armhf hurd-i386 i386 mips64el powerpc ppc64el riscv64 s390x] <!nocheck>,
- libfmt-dev,
  libgirepository1.0-dev <!nocheck>,
  libglib2.0-dev <!nocheck>,
  libgstreamer1.0-dev <!nocheck>,
