## cppgir 2.0+git20240928.c8bb1c6

=== debian/changelog ===
cppgir (2.0+git20240928.c8bb1c6-1) unstable; urgency=medium

  * Update to the latest upstream commit.
  * Remove previous patches taken from upstream Git.
  * Add data-ignore-deprecated-glib-symbol.patch instead.
  * Add multiarch directory to search paths for GIR XML. (Closes: #1060906)

 -- Nicholas Guriev <guriev-ns@ya.ru>  Fri, 03 Jan 2025 16:55:28 +0300

cppgir (2.0-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Add support for recent gio.

 -- Andrey Rakhmatullin <wrar@debian.org>  Mon, 28 Oct 2024 23:37:05 +0500

cppgir (2.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix crashing on Gio-2.0 (Closes: #1071302).
  * Fix several other FTBFS reasons.

 -- Andrey Rakhmatullin <wrar@debian.org>  Thu, 23 May 2024 23:50:03 +0500
