=== debian/watch ===
version=4
opts="mode=git, pretty=2.0+git%cd.%h" \
  https://gitlab.com/mnauw/cppgir heads/master
