## cppgir 2.0+git20240928.c8bb1c6+really2.0

=== debian/changelog ===
cppgir (2.0+git20240928.c8bb1c6+really2.0-1) unstable; urgency=medium

  * Non-maintainer upload.
  * Revert to older cppgir (Closes: #1092377)

 -- Salvo 'LtWorf' Tomaselli <ltworf@debian.org>  Fri, 11 Apr 2025 07:57:37 +0200
