=== debian/watch ===
version=4
https://gitlab.com/mnauw/cppgir/-/tags .*/@PACKAGE@[-_]?v?@ANY_VERSION@@ARCHIVE_EXT@
