## cppgir 2.0+git20250629.2a7d9ce

=== debian/changelog ===
cppgir (2.0+git20250629.2a7d9ce-2) unstable; urgency=medium

  * Add Rounding-in-tests.patch to fix build on i386.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Fri, 28 Nov 2025 10:54:34 +0300

cppgir (2.0+git20250629.2a7d9ce-1) unstable; urgency=medium

  * Update to the latest upstream commit.
  * Remove data-ignore-deprecated-glib-symbol.patch taken from upstream Git.
  * Migrate away from libgirepository1.0-dev, build depend on individual
    virtual packages with GIR XML. (Closes: #1118955)

 -- Nicholas Guriev <guriev-ns@ya.ru>  Mon, 17 Nov 2025 15:36:23 +0300
