=== debian/control ===
--- 
+++ 
@@ -5,10 +5,13 @@
 Build-Depends: debhelper-compat (= 13)
 Build-Depends-Arch:
  cmake (>= 3.14),
+ gir1.2-gio-2.0-dev <!nocheck>,
+ gir1.2-gobject-2.0-dev <!nocheck>,
+ gir1.2-gst-1.0-dev <!nocheck>,
+ gir1.2-gtk-3.0-dev <!nocheck>,
  libboost-dev (>= 1.58),
- libboost-fiber-dev (>= 1.65) [amd64 arm64 armel armhf hurd-i386 i386 mips64el powerpc ppc64el riscv64 s390x] <!nocheck>,
- libgirepository1.0-dev <!nocheck>,
- libglib2.0-dev <!nocheck>,
+ libboost-fiber-dev (>= 1.65) [i386 hurd-i386 kfreebsd-i386 amd64 kfreebsd-amd64 armel armhf arm64 loong64 mips mipsel mips64el powerpc ppc64el riscv64 s390x] <!nocheck>,
+ libgio-2.0-dev <!nocheck>,
  libgstreamer1.0-dev <!nocheck>,
  libgtk-3-dev <!nocheck>,
  qtbase5-dev (>= 5.9) <!nocheck>,
